//+------------------------------------------------------------------+
//|                                         EMA-Crossover_Signal.mq4 |
//|         Copyright  2005, Jason Robinson (jnrtrading)            |
//|                   http://www.jnrtading.co.uk                     |
//+------------------------------------------------------------------+

/*
  +------------------------------------------------------------------+
  | Allows you to enter two ema periods and it will then show you at |
  | Which point they crossed over. It is more usful on the shorter   |
  | periods that get obscured by the bars / candlesticks and when    |
  | the zoom level is out. Also allows you then to remove the emas   |
  | from the chart. (emas are initially set at 5 and 6)              |
  +------------------------------------------------------------------+
*/   
#property copyright "Copyright  2005, Jason Robinson (jnrtrading)"
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aquamarine
#property indicator_color2 Yellow
#property indicator_color3 Yellow
#property indicator_color4 Red
#property indicator_width1 5
#property indicator_width2 5
double CrossUp[];
double CrossDown[];
double prev;

extern int FasterMode = 3; //0=sma, 1=ema, 2=smma, 3=lwma//orig o, second 2
extern int FasterMA =   21;//orig 21,  second orig 5 third 18
extern int MediumMA    =   20;
extern int MediumMode  =    3;
extern int SlowerMode = 0; //0=sma, 1=ema, 2=smma, 3=lwma// orig 0 second 0
extern int SlowerMA =   55;// orig 55, second 40 third 28
extern bool lines=true;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
extern bool SoundON=true;
double alertBar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID);
   SetIndexArrow(0, 221);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID);
   SetIndexArrow(1, 222);
   SetIndexBuffer(1, CrossDown);
   //---- indicators
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer2);
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double fasterMAnow, slowerMAnow, fasterMAprevious, slowerMAprevious, 
fasterMAafter, slowerMAafter;
   double Range, AvgRange;
   double mediumMAnow, mediumMAprevious, mediumMAafter;
   int counted_bars=IndicatorCounted();
   int counted_bars1=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      fasterMAnow = iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE,i);
      fasterMAprevious = iMA(NULL, 0, FasterMA, 0, FasterMode,PRICE_CLOSE, i+1);
      fasterMAafter = iMA(NULL, 0, FasterMA, 0, FasterMode,PRICE_CLOSE, i-1);

      mediumMAnow = iMA(NULL, 0, MediumMA, 0, MediumMode, PRICE_CLOSE,i);
      mediumMAprevious = iMA(NULL, 0, MediumMA, 0, MediumMode,PRICE_CLOSE, i+1);
      mediumMAafter = iMA(NULL, 0, MediumMA, 0, MediumMode,PRICE_CLOSE, i-1);

      slowerMAnow = iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_CLOSE,i);
      slowerMAprevious = iMA(NULL, 0, SlowerMA, 0, SlowerMode,PRICE_CLOSE, i+1);
      slowerMAafter = iMA(NULL, 0, SlowerMA, 0, SlowerMode,PRICE_CLOSE, i-1);
    
      if ((fasterMAnow > slowerMAnow) && (fasterMAprevious < slowerMAprevious) && (fasterMAafter > slowerMAafter) && (mediumMAnow > slowerMAnow) || 
          (fasterMAnow > slowerMAnow) && (mediumMAnow > slowerMAnow) && (mediumMAprevious < slowerMAprevious)  &&
          (mediumMAafter > slowerMAafter)) {
         CrossUp[i] = Low[i] - Range*0.5;
         if (SoundON==true && Bars>alertBar ){
    Alert("Trendtest going UP on ",Symbol()," ",Period());
        alertBar = Bars;}
      }
      else if ((fasterMAnow < slowerMAnow) && (fasterMAprevious > slowerMAprevious) && (fasterMAafter < slowerMAafter) && (mediumMAnow < slowerMAnow) || 
         (fasterMAnow < slowerMAnow) && (mediumMAnow < slowerMAnow) && (mediumMAprevious > slowerMAprevious) && (mediumMAafter < slowerMAafter)) {
         CrossDown[i] = High[i] + Range*0.5;
         if (SoundON==true && Bars>alertBar ){
        Alert("Trendtest going Down on ",Symbol()," ",Period());
          alertBar = Bars;
        }
      }
   }


//---- check for possible errors
   if (counted_bars1<0) return(-1);
//---- last counted bar will be recounted
   if (counted_bars1>0) counted_bars1--;
   
   int pos=Bars-counted_bars1-1;
   
     
 
   while(pos>=0 && lines == true)
     {
         ExtMapBuffer1[pos]= iMA(NULL,0,FasterMA,0,FasterMode,PRICE_CLOSE,pos);

         ExtMapBuffer2[pos]= iMA(NULL,0,SlowerMA,0,SlowerMode,PRICE_CLOSE,pos);

   
         pos--;
     }

//----      

   return(0);
}


       